Option Explicit
'
' Windows API function declarations
'
Declare Function GetWindow Lib "User" (ByVal hWnd As Integer, ByVal wCmd As Integer) As Integer
Declare Function GetParent Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function GetClassName Lib "User" (ByVal hWnd As Integer, ByVal lpClassName As String, ByVal nMaxCount As Integer) As Integer
Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
Declare Function GetDC Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function ReleaseDC Lib "User" (ByVal hWnd As Integer, ByVal hDC As Integer) As Integer
'
' Constant used by GetParent
'
Global Const GW_CHILD = 5
'
' Constants used by GetWindow
'
Global Const GW_HWNDFIRST = 0
Global Const GW_HWNDNEXT = 2
'
' Constants used to define window messages
'
Global Const WM_ERASEBKGND = &H14
Global Const WM_SHOWWINDOW = &H18
'
' Identifier for the WM_SHOWWINDOW message
'
Global Const SW_PARENTCLOSING = 1

Private Function GetCaptionHandle (hWndIcon As Integer) As Integer
   Dim hWndCap As Integer
   Dim Buffer As String
   Dim nRet As Integer
   '
   ' Get the first top-level window in the master list.The
   ' caption window is identified by being the child of the
   ' icon, and by the Windows 3.x classname for captions --
   ' #32772.Loop until we've either checked all top-level
   ' windows, or until we find the icon's caption window.
   ' After each failed match, retrieve the next top-level
   ' window in the master list.
   '
   hWndCap = GetWindow(hWndIcon, GW_HWNDFIRST)
   Do While hWndCap <> 0
      If GetParent(hWndCap) = hWndIcon Then
         Buffer$ = Space$(128)
         nRet = GetClassName(hWndCap, Buffer$, Len(Buffer$))
         Buffer$ = Left$(Buffer$, nRet)
         If Buffer$ = "#32772" Then
            GetCaptionHandle = hWndCap
            Exit Function
         End If
      End If
      hWndCap = GetWindow(hWndCap, GW_HWNDNEXT)
   Loop
End Function

Sub MdiCaptionUpdate (mFrm As MDIForm, Cap$)
   Dim nRet As Integer
   Dim hWndCap As Integer
   Dim hDCCap As Integer
   '
   ' Set new caption into its window
   '
   mFrm.Caption = Cap$
   '
   ' If the form is minimized, then get the caption window's
   ' window handle, and send it the required message to
   ' initiate a repaint.
   '
   If mFrm.WindowState = 1 Then
      hWndCap = GetCaptionHandle((mFrm.hWnd))
      If hWndCap Then
         nRet = SendMessage(hWndCap, WM_SHOWWINDOW, SW_PARENTCLOSING, 0&)
         hDCCap = GetDC(hWndCap)
         nRet = SendMessage(hWndCap, WM_ERASEBKGND, hDCCap, 0&)
         nRet = ReleaseDC(hWndCap, hDCCap)
      End If
   End If
End Sub

